//rww - bot routines, this is a big ugly horrible thing and it's stupid.

#include "qwsvdef.h"

extern cvar_t	maxclients;
extern cvar_t	maxspectators;

extern int g_ri_state;
extern int g_ri_activepl;

extern qboolean QR_InDangerZone(float *pos);
qboolean SVC_DirectBotConnect (edict_t *botent);

#define BOT_TRAVEL_TIMEOUT			10.0
#define BOT_WAYPOINT_AVOIDTIME		10.0
#define BOT_WAYPOINT_CHECKDIST		16.0f
#define BOT_WAYPOINT_PICKUPDIST		1024.0f//256.0f
#define BOT_TRAVELDIR_FWD			0
#define BOT_TRAVELDIR_BACK			1

//todo - implement non-retarded pathing system
typedef struct botWaypoint_s
{
	float		pos[3];
} botWaypoint_t;

botWaypoint_t *g_botWaypoints = NULL;
int g_numBotWaypoints = 0;

typedef struct botAI_s
{
	botWaypoint_t	*wp;
	client_t		*cl;
	edict_t			*ed;
	usercmd_t		ucmd;

	float			lostDir[3];

	double			noWaypointTime;

	qboolean		hintValid;
	float			hintPos[3];
	qboolean		preHintValid;
	float			preHintPos[3];

	int				travelDir;
	double			travelTimeOut;
	float			travelPos[3];
	double			debugDebounce;

	double			strafeTime;

	client_t		*enemy;
} botAI_t;
botAI_t g_botAI[MAX_CLIENTS];

void Bot_AddBot (void);

//for visual debugging
void BotAI_BroadcastDebug(botAI_t *ai, float *pos)
{
	if (ai->debugDebounce >= realtime)
	{
		return;
	}
	ai->debugDebounce = realtime + 1.0;
	MSG_WriteByte(&sv.multicast, svc_temp_entity);
	MSG_WriteByte(&sv.multicast, TE_TELEPORT);
	MSG_WriteCoord(&sv.multicast, pos[0]);
	MSG_WriteCoord(&sv.multicast, pos[1]);
	MSG_WriteCoord(&sv.multicast, pos[2]);
	SV_Multicast(pos, MULTICAST_PHS);
}

//convenience function
trace_t BotAI_VisibilityTrace(botAI_t *ai, float *pos)
{
	float ofs[3];
	VectorAdd(ai->ed->v.origin, ai->ed->v.view_ofs, ofs);
	return SV_Move(ofs, vec3_origin, vec3_origin, pos, MOVE_NOMONSTERS, ai->ed);
}

//vectoangles
void BotAI_VecToAngles(vec3_t vec, vec3_t ang)
{
	float	forward;
	float	yaw, pitch;
	
	if (vec[1] == 0 && vec[0] == 0)
	{
		yaw = 0;
		if (vec[2] > 0)
			pitch = 90;
		else
			pitch = 270;
	}
	else
	{
		yaw = (int) (atan2(vec[1], vec[0]) * 180 / M_PI);
		if (yaw < 0)
			yaw += 360;

		forward = sqrt (vec[0]*vec[0] + vec[1]*vec[1]);
		pitch = (int) (atan2(vec[2], forward) * 180 / M_PI);
		if (pitch < 0)
			pitch += 360;
	}

	ang[0] = pitch;
	ang[1] = yaw;
	ang[2] = 0;
}


//ugly move check
qboolean BotAI_CanMoveTo(botAI_t *ai, float *pos, trace_t *tr)
{
	float fromPos[3], toPos[3];
	float fwd[3], right[3];
	float ang[3];
	int moveType = MOVE_NORMAL;//MOVE_NOMONSTERS;
	float nPos[3];

	VectorCopy(pos, nPos);
	nPos[2] = 0.0f;
	VectorNormalize(nPos);
	VectorScale(nPos, 32.0f, nPos);

	VectorSubtract(nPos, ai->ed->v.origin, fwd);
	VectorNormalize(fwd);
	BotAI_VecToAngles(fwd, ang);
	AngleVectors(ang, fwd, right, 0);

	VectorCopy(ai->ed->v.origin, fromPos);
	VectorAdd(fromPos, nPos, toPos);
	*tr = SV_Move(ai->ed->v.origin, vec3_origin, vec3_origin, toPos, moveType, ai->ed);
	if (tr->fraction != 1.0f)
	{
		return false;
	}

	VectorCopy(ai->ed->v.origin, fromPos);
	fromPos[2] += 28.0f;
	VectorAdd(fromPos, nPos, toPos);
	*tr = SV_Move(fromPos, vec3_origin, vec3_origin, toPos, moveType, ai->ed);
	if (tr->fraction != 1.0f)
	{
		return false;
	}

	VectorCopy(ai->ed->v.origin, fromPos);
	fromPos[2] -= 12.0f;
	VectorAdd(fromPos, nPos, toPos);
	*tr = SV_Move(fromPos, vec3_origin, vec3_origin, toPos, moveType, ai->ed);
	if (tr->fraction != 1.0f)
	{
		return false;
	}

	VectorMA(ai->ed->v.origin, 16.0f, right, fromPos);
	VectorAdd(fromPos, nPos, toPos);
	*tr = SV_Move(fromPos, vec3_origin, vec3_origin, toPos, moveType, ai->ed);
	if (tr->fraction != 1.0f)
	{
		return false;
	}

	VectorMA(ai->ed->v.origin, -16.0f, right, fromPos);
	VectorAdd(fromPos, nPos, toPos);
	*tr = SV_Move(fromPos, vec3_origin, vec3_origin, toPos, moveType, ai->ed);
	if (tr->fraction != 1.0f)
	{
		return false;
	}

	VectorMA(ai->ed->v.origin, 16.0f, right, fromPos);
	fromPos[2] -= 8.0f;
	VectorAdd(fromPos, nPos, toPos);
	*tr = SV_Move(fromPos, vec3_origin, vec3_origin, toPos, moveType, ai->ed);
	if (tr->fraction != 1.0f)
	{
		return false;
	}

	VectorMA(ai->ed->v.origin, -16.0f, right, fromPos);
	fromPos[2] -= 8.0f;
	VectorAdd(fromPos, nPos, toPos);
	*tr = SV_Move(fromPos, vec3_origin, vec3_origin, toPos, moveType, ai->ed);
	if (tr->fraction != 1.0f)
	{
		return false;
	}

	return true;
}

//see if i should try jumping to get here
qboolean BotAI_ShouldJump(botAI_t *ai, float *pos)
{
	trace_t tr;
	if ((ai->travelTimeOut-realtime) < 5.0 && rand()%10 < 5)
	{
		return true;
	}

	if (!BotAI_CanMoveTo(ai, pos, &tr))
	{
		if (g_ri_state != 2)
		{
			if (tr.ent && !strcmp(PR_GetString(tr.ent->v.classname), "monster_kitano"))
			{
				return false;
			}
			return true;
		}
		else
		{
			if (rand()%10 < 5)
			{
				return true;
			}
		}
	}

	return false;
}

//try moving toward something, returns true if <= idealDist
qboolean BotAI_MoveToTarget(botAI_t *ai, float *pos, float idealDist)
{
	float d[3];
	float len;

	//BotAI_BroadcastDebug(ai, pos);

	VectorSubtract(pos, ai->ed->v.origin, d);
	len = VectorNormalize(d);
	d[2] = 0.0f;
	BotAI_VecToAngles(d, d);
	d[YAW] -= ai->ed->v.v_angle[YAW];
	AngleVectors(d, d, 0, 0);

	if (pos[0] != ai->travelPos[0] || pos[1] != ai->travelPos[1] || pos[2] != ai->travelPos[2])
	{
		ai->travelTimeOut = realtime + BOT_TRAVEL_TIMEOUT;
		VectorCopy(pos, ai->travelPos);
	}

	if (ai->strafeTime > realtime)
	{
		ai->ucmd.forwardmove = 0;
		ai->ucmd.sidemove = (short)(-sv_maxspeed.value);
	}
	else
	{
		ai->ucmd.forwardmove = (short)(d[0]*sv_maxspeed.value);
		ai->ucmd.sidemove = -(short)(d[1]*sv_maxspeed.value);
	}

	if (BotAI_ShouldJump(ai, pos))
	{
		if (g_ri_state != 2)
		{
			ai->strafeTime = realtime + 0.5;
		}
		else
		{
			ai->ucmd.buttons |= 2;
		}
	}

	if (len <= idealDist)
	{
		return true;
	}
	return false;
}

//don't know where the hell i am
void BotAI_ConfusedRoaming(botAI_t *ai)
{
	float p[3];
	trace_t tr;

	if (Length(ai->lostDir) < 0.001f)
	{
		ai->lostDir[0] = 1.0f;
		ai->lostDir[1] = 0.0f;
		ai->lostDir[2] = 0.0f;
	}

	VectorMA(ai->ed->v.origin, 48.0f, ai->lostDir, p);
	BotAI_MoveToTarget(ai, p, 0.0f);

	if (!BotAI_CanMoveTo(ai, p, &tr))
	{
		ai->lostDir[0] += tr.plane.normal[0] + -0.1f + ((float)(rand()%8192)/8192.0f)*0.2f;
		ai->lostDir[1] += tr.plane.normal[1] + -0.1f + ((float)(rand()%8192)/8192.0f)*0.2f;
		ai->lostDir[2] = 0.0f;
		VectorNormalize(ai->lostDir);
	}
}

//grab a nearby waypoint
botWaypoint_t *BotAI_FindWaypoint(botAI_t *ai)
{
	int i;
	float bestDist;
	botWaypoint_t *closestWP = NULL;
	if (ai->noWaypointTime > realtime)
	{
		return NULL;
	}
	for (i = 0; i < g_numBotWaypoints; i++)
	{
		float d[3];
		float len;
		trace_t tr;
		botWaypoint_t *wp = g_botWaypoints+i;

		VectorSubtract(ai->ed->v.origin, wp->pos, d);
		len = Length(d);
		if (len > BOT_WAYPOINT_PICKUPDIST)
		{
			continue;
		}

		tr = BotAI_VisibilityTrace(ai, wp->pos);
		if (tr.startsolid || tr.allsolid || tr.fraction != 1.0f)
		{
			continue;						
		}

		if (!closestWP || len < bestDist)
		{
			closestWP = wp;
			bestDist = len;
		}
	}

	return closestWP;
}

//get the next waypoint in the chain
botWaypoint_t *BotAI_NextWP(botAI_t *ai, botWaypoint_t *wp)
{
	if (ai->travelDir == BOT_TRAVELDIR_FWD)
	{
		if ((g_botWaypoints+g_numBotWaypoints-1) <= wp)
		{ //last one
			ai->travelDir = BOT_TRAVELDIR_BACK;
			return (g_botWaypoints+g_numBotWaypoints-1);
		}
		else
		{
			return wp+1;
		}
	}
	else
	{
		if (g_botWaypoints >= wp)
		{ //first one
			ai->travelDir = BOT_TRAVELDIR_FWD;
			return g_botWaypoints;
		}
		else
		{
			return wp-1;
		}
	}
}

//ripped from PF_changeyaw
float BotAI_AdjustToAngle(float ang, float idealAng, float speed)
{
	float move;
	float current = anglemod(ang);

	if (current == idealAng)
		return current;
	move = idealAng - current;
	if (idealAng > current)
	{
		if (move >= 180)
			move = move - 360;
	}
	else
	{
		if (move <= -180)
			move = move + 360;
	}
	if (move > 0)
	{
		if (move > speed)
			move = speed;
	}
	else
	{
		if (move < -speed)
			move = -speed;
	}
	
	return anglemod (current + move);
}

//find an enemy
client_t *BotAI_EngageEnemy(botAI_t *ai)
{
	int i;
	client_t *bestEnemy = ai->enemy;
	float bestEnemyDist;

	if (g_ri_state != 2) //RRSTATE_INPROGRESS
	{
		return NULL;
	}

	if (bestEnemy)
	{
		if (!bestEnemy->edict || bestEnemy->state != cs_spawned || bestEnemy->spectator ||
			bestEnemy->edict->v.health <= 0)
		{
			bestEnemy = NULL;
		}
		else
		{
			trace_t tr;
			tr = BotAI_VisibilityTrace(ai, bestEnemy->edict->v.origin);
			if (tr.fraction != 1.0f && tr.ent != bestEnemy->edict)
			{
				bestEnemy = NULL;
			}
			else
			{
				float d[3];
				VectorSubtract(bestEnemy->edict->v.origin, ai->ed->v.origin, d);
				bestEnemyDist = Length(d);
			}
		}
	}

	for (i = 0; i < MAX_CLIENTS; i++)
	{
		client_t *cl = svs.clients+i;
		if (cl == ai->cl)
		{
			continue;
		}

		if (cl->state == cs_spawned && !cl->spectator && cl->edict && cl->edict->v.health > 0)
		{
			trace_t tr;
			float d[3];
			float dist;

			tr = BotAI_VisibilityTrace(ai, cl->edict->v.origin);
			if (tr.fraction == 1.0f || tr.ent == cl->edict)
			{
				VectorSubtract(cl->edict->v.origin, ai->ed->v.origin, d);
				dist = Length(d);

				if (!bestEnemy || (dist+128.0f) < bestEnemyDist)
				{
					bestEnemy = cl;
					bestEnemyDist = dist;
				}
			}
		}
	}

	return bestEnemy;
}

//decide where we should look
void BotAI_AdjustViewAngles(botAI_t *ai)
{
	float d[3];
	float angSpeed = 0.2f;

	if (ai->enemy)
	{
		VectorSubtract(ai->enemy->edict->v.origin, ai->ed->v.origin, d);
		angSpeed = 2.0f;
	}
	else
	{
		VectorSubtract(ai->travelPos, ai->ed->v.origin, d);
		d[2] = 0.0f;
	}

	BotAI_VecToAngles(d, d);
	d[PITCH] = -d[PITCH];
	ai->ed->v.v_angle[PITCH] = BotAI_AdjustToAngle(ai->ed->v.v_angle[PITCH], d[PITCH], angSpeed);
	ai->ed->v.v_angle[YAW] = BotAI_AdjustToAngle(ai->ed->v.v_angle[YAW], d[YAW], angSpeed);
	ai->ed->v.v_angle[ROLL] = 0.0f;
}

//the required distance to start firing
float BotAI_FiringRangeForWeapon(int weapon)
{
	float d;
	switch (weapon)
	{
	case IT_AXE:
		d = 128.0f;
		break;
	case IT_SHOTGUN:
		d = 2048.0f;
		break;
	case IT_SUPER_SHOTGUN:
		d = 768.0f;
		break;
	case IT_NAILGUN:
		d = 2048;
		break;
	case IT_SUPER_NAILGUN:
		d = 2048;
		break;
	case IT_GRENADE_LAUNCHER:
		d = 1024.0f;
		break;
	case IT_ROCKET_LAUNCHER:
		d = 4096.0f;
		break;
	case IT_LIGHTNING:
		d = 512.0f;
		break;
	default:
		d = 4096.0f;
		break;
	}

	return d;
}

//hint from game code
void Bot_ProvideHint(int clNum, float *pos)
{
	botAI_t *ai = &g_botAI[clNum];
	if (!ai->ed)
	{
		return;
	}
	VectorCopy(pos, ai->hintPos);
	VectorCopy(ai->ed->v.origin, ai->preHintPos);
	ai->hintValid = true;
	ai->preHintValid = true;
}

//individual bot client think
void Bot_Think(botAI_t *ai, float time)
{
	client_t *bot = ai->cl;

	memset(&ai->ucmd, 0, sizeof(ai->ucmd));
	ai->ucmd.msec = time*1000.0f;

	if (ai->ed->v.health <= 0)
	{ //respawn
		ai->enemy = NULL;
		ai->wp = NULL;
		if (rand()%10 < 2)
		{
			ai->ucmd.buttons |= 1;
		}
	}
	else
	{
		if (g_numBotWaypoints <= 0 || !g_botWaypoints)
		{
			BotAI_ConfusedRoaming(ai);
		}
		else
		{
			if (g_ri_state != 2)
			{
				ai->travelTimeOut = realtime + BOT_TRAVEL_TIMEOUT;
				if (ai->hintValid)
				{
					if (BotAI_MoveToTarget(ai, ai->hintPos, 64.0f))
					{
						ai->hintValid = false;
					}
				}
				else if (ai->preHintValid)
				{
					if (BotAI_MoveToTarget(ai, ai->preHintPos, 32.0f))
					{
						ai->preHintValid = false;
					}
				}
				else
				{
					int i;
					for (i = MAX_CLIENTS+1; i < sv.num_edicts ; i++)
					{
						edict_t *ed = EDICT_NUM(i);
						if (!strcmp(PR_GetString(ed->v.classname), "monster_kitano"))
						{
							VectorCopy(ed->v.origin, ai->travelPos);
							break;
						}
					}
				}
			}
			else
			{
				if (!ai->wp)
				{
					ai->wp = BotAI_FindWaypoint(ai);
					if (!ai->wp)
					{
						BotAI_ConfusedRoaming(ai);
					}
				}

				if (ai->wp)
				{
					if (BotAI_MoveToTarget(ai, ai->wp->pos, BOT_WAYPOINT_CHECKDIST))
					{
						botWaypoint_t *oldWP = ai->wp;
						ai->wp = BotAI_NextWP(ai, ai->wp);
						if (QR_InDangerZone(ai->wp->pos) && !QR_InDangerZone(oldWP->pos))
						{ //don't run into danger
							ai->wp = oldWP;
							ai->travelDir = !ai->travelDir;
						}
					}
					else if (ai->travelTimeOut < realtime)
					{
						ai->wp = NULL;
						ai->noWaypointTime = realtime + BOT_WAYPOINT_AVOIDTIME;
					}
				}
			}
		}

		ai->enemy = BotAI_EngageEnemy(ai);
		if (ai->enemy)
		{
			float d[3];
			VectorSubtract(ai->ed->v.origin, ai->enemy->edict->v.origin, d);
			if (Length(d) <= BotAI_FiringRangeForWeapon(ai->ed->v.weapon))
			{
				ai->ucmd.buttons |= 1;
			}
		}

		//stupid hack
		if ((((int)ai->ed->v.items) & IT_LIGHTNING) && ai->ed->v.ammo_cells > 0)
		{
			ai->ed->v.weapon = IT_LIGHTNING;
		}
		else if ((((int)ai->ed->v.items) & IT_ROCKET_LAUNCHER) && ai->ed->v.ammo_rockets > 0)
		{
			ai->ed->v.weapon = IT_ROCKET_LAUNCHER;
		}
		else if ((((int)ai->ed->v.items) & IT_GRENADE_LAUNCHER) && ai->ed->v.ammo_rockets > 0)
		{
			ai->ed->v.weapon = IT_GRENADE_LAUNCHER;
		}
		else if ((((int)ai->ed->v.items) & IT_SUPER_NAILGUN) && ai->ed->v.ammo_nails > 1)
		{
			ai->ed->v.weapon = IT_SUPER_NAILGUN;
		}
		else if ((((int)ai->ed->v.items) & IT_SUPER_SHOTGUN) && ai->ed->v.ammo_shells > 1)
		{
			ai->ed->v.weapon = IT_SUPER_SHOTGUN;
		}
		else if ((((int)ai->ed->v.items) & IT_NAILGUN) && ai->ed->v.ammo_nails > 0)
		{
			ai->ed->v.weapon = IT_NAILGUN;
		}
		else if ((((int)ai->ed->v.items) & IT_SHOTGUN) && ai->ed->v.ammo_shells > 0)
		{
			ai->ed->v.weapon = IT_SHOTGUN;
		}
		else
		{
			ai->ed->v.weapon = IT_AXE;
		}

		BotAI_AdjustViewAngles(ai);
	}

	ai->ucmd.angles[0] = ai->ed->v.v_angle[0];
	ai->ucmd.angles[1] = ai->ed->v.v_angle[1];
	ai->ucmd.angles[2] = ai->ed->v.v_angle[2];

	sv_player = ai->ed;
	host_client = bot;

	SV_PreRunCmd();
	SV_RunCmd(&ai->ucmd);
	SV_PostRunCmd();

	bot->lastcmd = ai->ucmd;

	//reset the outgoing message channel again
	bot->netchan.message.cursize = 0;
	bot->netchan.message.overflowed = false;
	bot->backbuf.cursize = 0;
	bot->backbuf.overflowed = false;
}

//frame function for all bot logic
void Bot_Frame(float time)
{
	int i;
	for (i = 0; i < MAX_CLIENTS; i++)
	{
		client_t *cl = svs.clients+i;
		if (cl->state == cs_spawned && cl->edict && cl->netchan.fakechan)
		{
			Bot_Think(&g_botAI[i], time);
		}
	}
}

//per-map initialization
void Bot_MapInit(void)
{
	char truncbspname[MAX_OSPATH];
	char *p;
	FILE *f = NULL;
	int len;
	int i;

	for (i = 0; i < MAX_CLIENTS; i++)
	{
		botAI_t *ai = &g_botAI[i];
		client_t *cl = ai->cl;
		edict_t *ed = ai->ed;
		memset(ai, 0, sizeof(botAI_t));
		ai->cl = cl;
		ai->ed = ed;
	}

	if (g_botWaypoints)
	{
		free(g_botWaypoints);
		g_botWaypoints = NULL;
	}
	g_numBotWaypoints = 0;

	if (!sv.worldmodel)
	{
		return;
	}

	strcpy(truncbspname, sv.worldmodel->name);
	p = strstr(truncbspname, ".bsp");
	if (p)
	{
		*p = 0;
	}
	strcat(truncbspname, ".qrb");

	len = COM_FOpenFile(truncbspname, &f);
	if (len <= 0 || !f)
	{
		return;
	}

	fread(&g_numBotWaypoints, sizeof(g_numBotWaypoints), 1, f);
	g_botWaypoints = malloc(sizeof(botWaypoint_t)*g_numBotWaypoints);
	fread(g_botWaypoints, sizeof(botWaypoint_t), g_numBotWaypoints, f);
	fclose(f);
}

//final shutdown
void Bot_Shutdown(void)
{
	if (g_botWaypoints)
	{
		free(g_botWaypoints);
		g_botWaypoints = NULL;
	}
	g_numBotWaypoints = 0;
}

//general bot initialization
void Bot_Init(void)
{
	Cmd_AddCommand ("addbot", Bot_AddBot);
}

char *g_botInfos[MAX_CLIENTS] =
{
	"\\*ver\\2.40-0373\\name\\Haruka\\noaim\\1\\msg\\1\\rate\\8000\\bottomcolor\\8\\topcolor\\10\\skin\\base\\pmodel\\33168\\emodel\\6967\\*ip\\127.0.0.1:27500",
	"\\*ver\\2.40-0373\\name\\Shuya\\noaim\\1\\msg\\1\\rate\\8000\\bottomcolor\\0\\topcolor\\1\\skin\\base\\pmodel\\33168\\emodel\\6967\\*ip\\127.0.0.1:27500",
	"\\*ver\\2.40-0373\\name\\Noriko\\noaim\\1\\msg\\1\\rate\\8000\\bottomcolor\\13\\topcolor\\13\\skin\\base\\pmodel\\33168\\emodel\\6967\\*ip\\127.0.0.1:27500",
	"\\*ver\\2.40-0373\\name\\Nobu\\noaim\\1\\msg\\1\\rate\\8000\\bottomcolor\\2\\topcolor\\2\\skin\\base\\pmodel\\33168\\emodel\\6967\\*ip\\127.0.0.1:27500",
	"\\*ver\\2.40-0373\\name\\Kazuo\\noaim\\1\\msg\\1\\rate\\8000\\bottomcolor\\4\\topcolor\\12\\skin\\base\\pmodel\\33168\\emodel\\6967\\*ip\\127.0.0.1:27500",
	"\\*ver\\2.40-0373\\name\\Sawada\\noaim\\1\\msg\\1\\rate\\8000\\bottomcolor\\5\\topcolor\\7\\skin\\base\\pmodel\\33168\\emodel\\6967\\*ip\\127.0.0.1:27500",
	"\\*ver\\2.40-0373\\name\\Shougo\\noaim\\1\\msg\\1\\rate\\8000\\bottomcolor\\6\\topcolor\\8\\skin\\base\\pmodel\\33168\\emodel\\6967\\*ip\\127.0.0.1:27500",
	"\\*ver\\2.40-0373\\name\\Takako\\noaim\\1\\msg\\1\\rate\\8000\\bottomcolor\\10\\topcolor\\9\\skin\\base\\pmodel\\33168\\emodel\\6967\\*ip\\127.0.0.1:27500",
	"\\*ver\\2.40-0373\\name\\Hiroki\\noaim\\1\\msg\\1\\rate\\8000\\bottomcolor\\13\\topcolor\\4\\skin\\base\\pmodel\\33168\\emodel\\6967\\*ip\\127.0.0.1:27500",
	"\\*ver\\2.40-0373\\name\\Shinji\\noaim\\1\\msg\\1\\rate\\8000\\bottomcolor\\3\\topcolor\\7\\skin\\base\\pmodel\\33168\\emodel\\6967\\*ip\\127.0.0.1:27500",
	"\\*ver\\2.40-0373\\name\\Yukie\\noaim\\1\\msg\\1\\rate\\8000\\bottomcolor\\3\\topcolor\\3\\skin\\base\\pmodel\\33168\\emodel\\6967\\*ip\\127.0.0.1:27500",
	"\\*ver\\2.40-0373\\name\\Fumiyo\\noaim\\1\\msg\\1\\rate\\8000\\bottomcolor\\5\\topcolor\\5\\skin\\base\\pmodel\\33168\\emodel\\6967\\*ip\\127.0.0.1:27500",
	"\\*ver\\2.40-0373\\name\\Satomi\\noaim\\1\\msg\\1\\rate\\8000\\bottomcolor\\6\\topcolor\\6\\skin\\base\\pmodel\\33168\\emodel\\6967\\*ip\\127.0.0.1:27500",
	"\\*ver\\2.40-0373\\name\\Kayoko\\noaim\\1\\msg\\1\\rate\\8000\\bottomcolor\\7\\topcolor\\7\\skin\\base\\pmodel\\33168\\emodel\\6967\\*ip\\127.0.0.1:27500",
	"\\*ver\\2.40-0373\\name\\Chiaki\\noaim\\1\\msg\\1\\rate\\8000\\bottomcolor\\8\\topcolor\\8\\skin\\base\\pmodel\\33168\\emodel\\6967\\*ip\\127.0.0.1:27500",
	"\\*ver\\2.40-0373\\name\\Seto\\noaim\\1\\msg\\1\\rate\\8000\\bottomcolor\\9\\topcolor\\9\\skin\\base\\pmodel\\33168\\emodel\\6967\\*ip\\127.0.0.1:27500",
	"\\*ver\\2.40-0373\\name\\Megumi\\noaim\\1\\msg\\1\\rate\\8000\\bottomcolor\\10\\topcolor\\10\\skin\\base\\pmodel\\33168\\emodel\\6967\\*ip\\127.0.0.1:27500",
	"\\*ver\\2.40-0373\\name\\Yukiko\\noaim\\1\\msg\\1\\rate\\8000\\bottomcolor\\11\\topcolor\\11\\skin\\base\\pmodel\\33168\\emodel\\6967\\*ip\\127.0.0.1:27500",
	"\\*ver\\2.40-0373\\name\\Yumiko\\noaim\\1\\msg\\1\\rate\\8000\\bottomcolor\\12\\topcolor\\12\\skin\\base\\pmodel\\33168\\emodel\\6967\\*ip\\127.0.0.1:27500",
	"\\*ver\\2.40-0373\\name\\Yuka\\noaim\\1\\msg\\1\\rate\\8000\\bottomcolor\\12\\topcolor\\1\\skin\\base\\pmodel\\33168\\emodel\\6967\\*ip\\127.0.0.1:27500",
	"\\*ver\\2.40-0373\\name\\Chisato\\noaim\\1\\msg\\1\\rate\\8000\\bottomcolor\\13\\topcolor\\2\\skin\\base\\pmodel\\33168\\emodel\\6967\\*ip\\127.0.0.1:27500",
	"\\*ver\\2.40-0373\\name\\Shou\\noaim\\1\\msg\\1\\rate\\8000\\bottomcolor\\1\\topcolor\\3\\skin\\base\\pmodel\\33168\\emodel\\6967\\*ip\\127.0.0.1:27500",
	"\\*ver\\2.40-0373\\name\\Yoshitoki\\noaim\\1\\msg\\1\\rate\\8000\\bottomcolor\\2\\topcolor\\4\\skin\\base\\pmodel\\33168\\emodel\\6967\\*ip\\127.0.0.1:27500",
	"\\*ver\\2.40-0373\\name\\Yutaka\\noaim\\1\\msg\\1\\rate\\8000\\bottomcolor\\3\\topcolor\\5\\skin\\base\\pmodel\\33168\\emodel\\6967\\*ip\\127.0.0.1:27500",
	"\\*ver\\2.40-0373\\name\\Iijima\\noaim\\1\\msg\\1\\rate\\8000\\bottomcolor\\4\\topcolor\\6\\skin\\base\\pmodel\\33168\\emodel\\6967\\*ip\\127.0.0.1:27500",
	"\\*ver\\2.40-0373\\name\\Kyouichi\\noaim\\1\\msg\\1\\rate\\8000\\bottomcolor\\6\\topcolor\\8\\skin\\base\\pmodel\\33168\\emodel\\6967\\*ip\\127.0.0.1:27500",
	"\\*ver\\2.40-0373\\name\\Hirono\\noaim\\1\\msg\\1\\rate\\8000\\bottomcolor\\7\\topcolor\\9\\skin\\base\\pmodel\\33168\\emodel\\6967\\*ip\\127.0.0.1:27500",
	"\\*ver\\2.40-0373\\name\\Mitsuru\\noaim\\1\\msg\\1\\rate\\8000\\bottomcolor\\9\\topcolor\\11\\skin\\base\\pmodel\\33168\\emodel\\6967\\*ip\\127.0.0.1:27500",
	"\\*ver\\2.40-0373\\name\\Ryuhei\\noaim\\1\\msg\\1\\rate\\8000\\bottomcolor\\10\\topcolor\\10\\skin\\base\\pmodel\\33168\\emodel\\6967\\*ip\\127.0.0.1:27500",
	"\\*ver\\2.40-0373\\name\\Izumi\\noaim\\1\\msg\\1\\rate\\8000\\bottomcolor\\11\\topcolor\\6\\skin\\base\\pmodel\\33168\\emodel\\6967\\*ip\\127.0.0.1:27500",
	"\\*ver\\2.40-0373\\name\\Sakura\\noaim\\1\\msg\\1\\rate\\8000\\bottomcolor\\12\\topcolor\\7\\skin\\base\\pmodel\\33168\\emodel\\6967\\*ip\\127.0.0.1:27500",
	"\\*ver\\2.40-0373\\name\\Kazuhiko\\noaim\\1\\msg\\1\\rate\\8000\\bottomcolor\\13\\topcolor\\8\\skin\\base\\pmodel\\33168\\emodel\\6967\\*ip\\127.0.0.1:27500"
};

//get the userinfo string for a bot
const char *Bot_GetUserInfo(client_t *cl)
{
	int i = cl-svs.clients;
	return g_botInfos[i];
}

//alloc client ent
edict_t *Bot_ClientAlloc(client_t **clOut)
{
	int i;
	for (i = 0; i < MAX_CLIENTS; i++)
	{
		edict_t *e;
		client_t *cl = svs.clients+i;
		if (cl->state != cs_free)
		{
			continue;
		}

		e = EDICT_NUM(i+1);
		if (!((int)e->v.flags & FL_CLIENT))
		{
			ED_ClearEdict (e);
			if (clOut)
			{
				*clOut = cl;
			}
			return e;
		}
	}
	
	return NULL;
}

//create a bot ent and attach a client
void Bot_AddBot (void)
{
	edict_t *bot;
	int charnum = 0;
	usercmd_t ucmd;
	int i = 0;
	client_t *cl;
	int clients = 0;
	botAI_t *ai;

	for (i=0,cl=svs.clients ; i<MAX_CLIENTS ; i++,cl++)
	{
		if (cl->state == cs_free)
			continue;
		if (!cl->spectator)
			clients++;
	}

	// if at server limits, refuse connection
	if ( maxclients.value > MAX_CLIENTS )
		Cvar_SetValue ("maxclients", MAX_CLIENTS);
	if (maxspectators.value > MAX_CLIENTS)
		Cvar_SetValue ("maxspectators", MAX_CLIENTS);
	if (maxspectators.value + maxclients.value > MAX_CLIENTS)
		Cvar_SetValue ("maxspectators", MAX_CLIENTS - maxspectators.value + maxclients.value);
	if (clients >= (int)maxclients.value)
	{
		Sys_Printf("Server full, no room for a bot.\n");
		return;
	}

	bot = Bot_ClientAlloc(&cl);
	if (!bot)
	{
		Sys_Printf("Server full, no room for a bot.\n");
		return;
	}

	bot->free = false;
	bot->v.flags = FL_CLIENT;
	bot->v.model = PR_SetString("progs/player.mdl");
	bot->v.modelindex = SV_ModelIndex("progs/player.mdl");
	bot->v.weaponmodel = PR_SetString("progs/v_shot.mdl");
	bot->v.solid = SOLID_BBOX;
	bot->v.movetype = MOVETYPE_WALK;
	bot->v.takedamage = DAMAGE_AIM;
	cl->edict = bot;
	cl->messagelevel = 0;

	if (SVC_DirectBotConnect (bot) != true)
	{
		Sys_Printf("Server full, no room for a bot.\n");
		return;
	}

	cl->state = cs_spawned;

	SV_SendMessagesToAll();
	cl->edict->v.colormap = NUM_FOR_EDICT(cl->edict);
	cl->edict->v.team = 0;	// FIXME
	pr_global_struct->time = sv.time;
	pr_global_struct->self = EDICT_TO_PROG(cl->edict);
	PR_ExecuteProgram (pr_global_struct->ClientConnect);

	// actually spawn the player
	pr_global_struct->time = sv.time;
	pr_global_struct->self = EDICT_TO_PROG(cl->edict);
	PR_ExecuteProgram (pr_global_struct->PutClientInServer);	

	ai = &g_botAI[cl-svs.clients];
	ai->cl = cl;
	ai->ed = cl->edict;
}

//spawn the bot
void Bot_Spawn(client_t *botClient)
{
	int		i;
	client_t	*client;
	edict_t	*ent;
	eval_t *val;
	int n;

	if (botClient->state != cs_connected)
	{
		Con_Printf ("Spawn not valid -- allready spawned\n");
		return;
	}

	n = (botClient-svs.clients);

	// make sure n is valid
	if ( n < 0 || n > MAX_CLIENTS )
	{
		SV_New_f ();
		return;
	}
	
// send all current names, colors, and frag counts
	// FIXME: is this a good thing?
	SZ_Clear (&botClient->netchan.message);

// send current status of all other players

	// set up the edict
	ent = botClient->edict;

	memset (&ent->v, 0, progs->entityfields * 4);
	ent->v.colormap = NUM_FOR_EDICT(ent);
	ent->v.team = 0;	// FIXME
	ent->v.netname = PR_SetString(botClient->name);

	botClient->entgravity = 1.0;
	val = GetEdictFieldValue(ent, "gravity");
	if (val)
		val->_float = 1.0;
	botClient->maxspeed = sv_maxspeed.value;
	val = GetEdictFieldValue(ent, "maxspeed");
	if (val)
		val->_float = sv_maxspeed.value;

	memset (botClient->stats, 0, sizeof(botClient->stats));
}

//level change
void Bot_Respawn(client_t *cl)
{
	edict_t *bot = cl->edict;
	int i;
	eval_t *val;

	ED_ClearEdict (bot);

	memset (&bot->v, 0, progs->entityfields * 4);
	bot->v.colormap = NUM_FOR_EDICT(bot);
	bot->v.team = 0;	// FIXME
	bot->v.netname = PR_SetString(cl->name);

	cl->entgravity = 1.0;
	cl->entAlly = -1;
	val = GetEdictFieldValue(bot, "gravity");
	if (val)
		val->_float = 1.0;
	cl->maxspeed = sv_maxspeed.value;
	val = GetEdictFieldValue(bot, "maxspeed");
	if (val)
		val->_float = sv_maxspeed.value;

	bot->free = false;
	bot->v.flags = FL_CLIENT;
	bot->v.model = PR_SetString("progs/player.mdl");
	bot->v.modelindex = SV_ModelIndex("progs/player.mdl");
	bot->v.weaponmodel = PR_SetString("progs/v_shot.mdl");
	bot->v.solid = SOLID_BBOX;
	bot->v.movetype = MOVETYPE_WALK;
	bot->v.takedamage = DAMAGE_AIM;

	cl->sendinfo = true;

	Bot_Spawn(cl);

	PR_ExecuteProgram (pr_global_struct->SetNewParms);
	for (i=0 ; i<NUM_SPAWN_PARMS ; i++)
		cl->spawn_parms[i] = (&pr_global_struct->parm1)[i];

	cl->state = cs_spawned;

	SV_SendMessagesToAll();
	cl->edict->v.colormap = NUM_FOR_EDICT(cl->edict);
	cl->edict->v.team = 0;	// FIXME
	pr_global_struct->time = sv.time;
	pr_global_struct->self = EDICT_TO_PROG(cl->edict);
	PR_ExecuteProgram (pr_global_struct->ClientConnect);

	// actually spawn the player
	pr_global_struct->time = sv.time;
	pr_global_struct->self = EDICT_TO_PROG(cl->edict);
	PR_ExecuteProgram (pr_global_struct->PutClientInServer);	
}

//connect a bot
extern int g_userid;
qboolean SVC_DirectBotConnect (edict_t *botent)
{
	int			i;
	client_t	*cl;
	client_t	*newcl;
	int			edictnum;
	char		*s;
	qboolean	spectator;
	int			qport;
	int			challenge;
	netadr_t	adr;

	challenge = 0;

	newcl = &svs.clients[NUM_FOR_EDICT(botent)-1];
	g_userid++;
	newcl->userid = g_userid;

	edictnum = (newcl-svs.clients)+1;

	qport = BigShort(27500);
	adr.ip[0] = 127;
	adr.ip[1] = 0;
	adr.ip[2] = 0;
	adr.ip[3] = 1;
	adr.port = qport;
	Netchan_Setup (&newcl->netchan, adr, qport);
	newcl->netchan.fakechan = true;

	newcl->state = cs_connected;

	newcl->datagram.allowoverflow = true;
	newcl->datagram.data = newcl->datagram_buf;
	newcl->datagram.maxsize = sizeof(newcl->datagram_buf);

	newcl->edict = botent;

	strcpy(newcl->userinfo, Bot_GetUserInfo(newcl));
	
	SV_ExtractFromUserinfo (newcl);

	for (i=0; i<10; i++)
		newcl->whensaid[i] = 0.0;
	newcl->whensaidhead = 0;
	newcl->lockedtill = 0;

	Bot_Spawn(newcl);

	PR_ExecuteProgram (pr_global_struct->SetNewParms);

	for (i=0 ; i<NUM_SPAWN_PARMS ; i++)
		newcl->spawn_parms[i] = (&pr_global_struct->parm1)[i];

	if (newcl->spectator)
		Con_Printf ("Spectator %s connected\n", newcl->name);
	else
		Con_DPrintf ("Client %s connected\n", newcl->name);
	newcl->sendinfo = true;

	return true;
}
